﻿using UnityEngine;
using System.Runtime.InteropServices;
using System.Collections.Generic;
using System.Linq;

public class BrowserBindings : MonoBehaviour
{
  public static BrowserBindings Instance { get; private set; }

  public Dictionary<string, object> json;
  public Dictionary<string, object> current;
  public Stack<Dictionary<string, object>> jsonNest = new Stack<Dictionary<string, object>>();
  public Stack<object> array = null;


  //Browser part
  [DllImport("__Internal")]
  private static extern void Hello();

  [DllImport("__Internal")]
  private static extern void HelloString(string str);

  [DllImport("__Internal")]
  private static extern void PrintFloatArray(float[] array, int size);

  [DllImport("__Internal")]
  private static extern int AddNumbers(int x, int y);

  [DllImport("__Internal")]
  private static extern string StringReturnValueFunction();

  [DllImport("__Internal")]
  private static extern void BindWebGLTexture(int texture);

  //Unity part
  public void JSONBegin()
  {
    current = new Dictionary<string, object>();
    jsonNest.Push(current);
  }

  public void JSONPushString(string name, string value)
  {
    current.Add(name, value);
  }

  public void JSONPushNumber(string name, float value)
  {
    current.Add(name, value);
  }

  public void JSONPushBool(string name, bool value)
  {
    current.Add(name, value);
  }

  public void JSONPushJSON(string name) {
    var current = this.current;
    JSONBegin();
    current.Add(name, this.current);
  }

  public void JSONEnd()
  {
    json = jsonNest.Pop();
    if(jsonNest.Count > 0)
      current = jsonNest.Last();
  }

  public void StartLevel() {
    UnityEngine.SceneManagement.SceneManager.LoadScene("JsonTest");
  }

  //Native functions
  private void Awake()
  {
    GameObject.DontDestroyOnLoad(this);
    Instance = this;
  }

  /*void Start()
  {
    Hello();

    HelloString("This is a string.");

    float[] myArray = new float[10];
    PrintFloatArray(myArray, myArray.Length);

    int result = AddNumbers(5, 7);
    Debug.Log(result);

    Debug.Log(StringReturnValueFunction());

    var texture = new Texture2D(0, 0, TextureFormat.ARGB32, false);
    BindWebGLTexture(texture.GetNativeTextureID());
  }*/
}