﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class JsonTest : MonoBehaviour
{
  private int x;
  private int y;

  public void Start()
  {
    BrowserBindings.Instance.JSONBegin();
    BrowserBindings.Instance.JSONPushString("a", "test1");
    BrowserBindings.Instance.JSONPushString("b", "test2");
    BrowserBindings.Instance.JSONPushString("c", "test3");
    BrowserBindings.Instance.JSONPushNumber("float", 21.0f/7.0f);
    BrowserBindings.Instance.JSONPushBool("bool", true);

    BrowserBindings.Instance.JSONPushJSON("sub");
    BrowserBindings.Instance.JSONPushString("a", "test1");
    BrowserBindings.Instance.JSONPushString("b", "test2");
    BrowserBindings.Instance.JSONPushString("c", "test3");
    BrowserBindings.Instance.JSONPushNumber("float", 21.0f / 7.0f);
    BrowserBindings.Instance.JSONPushBool("bool", true);
    BrowserBindings.Instance.JSONEnd();

    BrowserBindings.Instance.JSONPushString("d", "test1");
    BrowserBindings.Instance.JSONEnd();
  }

  public void OnGUI()
  {
    x = y = 100;
    GUI.Label(new Rect(x, y, 100, 20), "JSON:");
    y += 20;

    ShowJSON(BrowserBindings.Instance.current);
  }

  private void ShowJSON(Dictionary<string, object> json)
  {
    x += 20;
    foreach (var o in json)
    {
      var key = o.Key;
      var val = o.Value;

      if (val is string || val is float || val is bool) {
        GUI.Label(new Rect(x, y, 100, 20), key + " = " + val.ToString());
      }
      else {
        var nested = val as Dictionary<string, object>;
        if (nested != null) {
          ShowJSON(nested);
        }
      }

      y += 20;
    }
    x -= 20;
  }
}
