﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SceneConfiguration : MonoBehaviour
{
  private static SceneConfiguration _instance;


  public UnityEngine.UI.Text textMinTimeStamp;
  public UnityEngine.UI.Text textMaxTimeStamp;
  public UnityEngine.UI.Text textCurrentTime;
  public UnityEngine.UI.Text textCurrentTimeLeft;
  public UnityEngine.UI.Text textCurrentTimeRight;

  public long minTimeStamp = long.MaxValue;
  public long maxTimeStamp = long.MinValue;


  public static SceneConfiguration Instance
  {
    get
    {
      return _instance;
    }
  }

  public void Awake()
  {
    _instance = this;
  }

  public void OnDestroy()
  {
    if (_instance == this)
    {
      _instance = null;
    }
  }
}
